;#########################################################################
;		Assembler directives

.486
.model flat,stdcall
option casemap:none

;#########################################################################
;		Include file

include CodeComplete.inc

.code

;#########################################################################
;		Common AddIn Procedures

DllEntry proc hInst:HINSTANCE,reason:DWORD,reserved1:DWORD

	mov		eax,hInst
	mov		hInstance,eax
	mov		eax,TRUE
	ret

DllEntry Endp

; Export this proc (it is autoexported if MakeDef is enabled with option 2)
InstallDll proc uses ebx,hWin:DWORD,fOpt:DWORD

	mov		ebx,hWin
	;Get pointer to handles struct
	invoke SendMessage,ebx,AIM_GETHANDLES,0,0	
	mov		lpHandles,eax
	;Get handle of unsorted popup listbox
	mov		eax,[eax].ADDINHANDLES.hLBU
	mov		hLB,eax
	;Get pointer to proc struct
	invoke SendMessage,ebx,AIM_GETPROCS,0,0
	mov		lpProc,eax

	;Get pointer to data struct
	invoke SendMessage,ebx,AIM_GETDATA,0,0	
	mov		lpData,eax

	; Messages to hook into
	mov		eax,RAM_CLOSE or RAM_MDIACTIVATE
	mov		ecx,RAM_UNHOOK
	; EDX must be null before we return
	xor		edx,edx
	ret

InstallDll Endp

IsLineCoInvoke proc uses esi edi,npos:DWORD

	mov		esi,offset linebuff
	mov		edi,offset szCoInvoke
	dec		esi
	mov		ecx,npos
	inc		ecx
  @@:
	dec		ecx
	je		Ex
	inc		esi
	mov		al,[esi]
	cmp		al,VK_SPACE
	je		@b
	cmp		al,VK_TAB
	je		@b
	dec		esi
	dec		edi
	inc		ecx
  @@:
	dec		ecx
	je		Ex
	inc		esi
	inc		edi
	mov		al,[edi]
	mov		ah,[esi]
;	;Not case sensitive
;	.if al>='a' && al<='z'
;		and		al,5Fh
;	.endif
;	.if ah>='a' && ah<='z'
;		and		ah,5Fh
;	.endif
	sub		ah,al
	je		@b
	.if !al && (ah==VK_SPACE || ah==VK_TAB)
		xor		eax,eax
	.endif
  @@:
	ret
  Ex:
	xor		eax,eax
	dec		eax
	ret

IsLineCoInvoke endp

UnHook proc hWin:HWND,lpThisProc:DWORD,lpOldProc:DWORD

	invoke GetWindowLong,hWin,GWL_WNDPROC
	.if eax==lpProc
		;Last in chain, just unhook
		invoke SetWindowLong,hWin,GWL_WNDPROC,lpOldProc
	.else
		;Let the next in the chain unhook me
		push	RAM_UNHOOK
		push	lpOldProc
		push	lpThisProc
		push	AIM_UNHOOK
		push	hWin
		mov		eax,lpProc
		call	[eax].ADDINPROCS.lpDllProc
	.endif
	ret

UnHook endp

ShowListBox proc hWin:HWND
	LOCAL	pt:POINT
	LOCAL	rect:RECT
	LOCAL	MaxX:DWORD
	LOCAL	MaxY:DWORD
	LOCAL	lbwt:DWORD
	LOCAL	lbht:DWORD
	LOCAL	lnht:DWORD

	;Get pointer to EDIT structure
	invoke GetWindowLong,hWin,0
	;Get line height
	mov		edx,[eax].EDIT.fntinfo.fntht
	add		edx,[eax].EDIT.fntinfo.linespace
	mov		lnht,edx
	;Get size of listbox
	invoke GetWindowRect,hLB,addr rect
	mov		eax,rect.right
	sub		eax,rect.left
	mov		lbwt,eax
	mov		eax,rect.bottom
	sub		eax,rect.top
	mov		lbht,eax
	;Get screen size
	invoke GetSystemMetrics,SM_CXSCREEN
	mov		MaxX,eax
	invoke GetSystemMetrics,SM_CYSCREEN
	mov		MaxY,eax
	;Get caret position
	invoke GetCaretPos,addr pt
	invoke ClientToScreen,hWin,addr pt
	;Position and show the LB
	mov		edx,lbwt
	mov		eax,pt.x
	add		eax,edx
	.if eax>MaxX
		sub		eax,MaxX
		sub		pt.x,eax
	.endif
	mov		edx,lbht
	mov		eax,pt.y
	add		eax,lnht
	add		eax,edx
	.if eax>MaxY
		add		edx,3
		sub		pt.y,edx
	.else
		mov		eax,lnht
		add		eax,3
		add		pt.y,eax
	.endif
	invoke MoveWindow,hLB,pt.x,pt.y,lbwt,lbht,TRUE
	invoke ShowWindow,hLB,SW_SHOWNOACTIVATE
	ret

ShowListBox endp

MdiChildProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL	pt:POINT

	.if uMsg==WM_NOTIFY
		push	ebx
		;Get pointer to RASELCHANGE structure
		mov		ebx,lParam
		;Check if it is SEL_TEXT notification
		.if [ebx].RASELCHANGE.seltyp==SEL_TEXT
			mov		eax,[ebx].RASELCHANGE.line
			.if eax!=nLine || [ebx].RASELCHANGE.fchanged
				mov		nLine,eax
				;Hide the listbox
				.if fLB
					invoke ShowWindow,hLB,SW_HIDE
					mov		fLB,FALSE
				.endif
				.if [ebx].RASELCHANGE.fchanged
					;Get the line text
					push	esi
					push	edi
					mov		esi,[ebx].RASELCHANGE.lpLine
					mov		ecx,[esi].CHARS.len
					lea		esi,[esi+sizeof CHARS]
					mov		edi,offset linebuff
					rep movsb
					;Zero terminate line
					mov		byte ptr [edi],0
					.if byte ptr [edi-1]==VK_RETURN
						;Dont want CR
						mov		byte ptr [edi-1],0
					.endif
					mov		eax,[ebx].RASELCHANGE.chrg.cpMin
					sub		eax,[ebx].RASELCHANGE.cpLine
					invoke IsLineCoInvoke,eax
					.if !eax
						invoke SendMessage,hLB,LB_RESETCONTENT,0,0
						;put some text into listbox
						push	esi
						mov		esi,offset szSomeText
						.while byte ptr [esi]
							invoke SendMessage,hLB,LB_ADDSTRING,0,esi
							invoke lstrlen,esi
							lea		esi,[esi+eax+1]
						.endw
						pop		esi
						;Set listbox position
						invoke GetFocus
						invoke ShowListBox,eax
						invoke SendMessage,hLB,LB_SETCURSEL,0,0
						mov		fLB,TRUE
					.endif
					pop		edi
					pop		esi
				.endif
			.endif
		.endif
		pop		ebx
	.endif
	invoke CallWindowProc,OldMdiChildProc,hWin,uMsg,wParam,lParam
	ret

MdiChildProc endp

EditProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL	buffer[64]:BYTE

	.if uMsg==WM_KEYDOWN
		mov		edx,wParam
		mov		eax,lParam
		shr		eax,16
		and		eax,3FFh
		.if edx==28h && (eax==150h || eax==50h)
			;Down
			invoke IsWindowVisible,hLB
			.if eax
				invoke SendMessage,hLB,LB_SETCURSEL,1,0
				invoke SetFocus,hLB
				xor		eax,eax
				jmp		Ex
			.endif
		.endif
	.elseif uMsg==WM_CHAR
		mov		eax,wParam
		.if eax==VK_TAB && fLB
			invoke SendMessage,hLB,LB_GETCURSEL,0,0
			.if eax!=LB_ERR
				mov		edx,eax
				invoke SendMessage,hLB,LB_GETTEXT,edx,addr buffer
				invoke GetParent,hWin
				mov		edx,eax
				invoke SendMessage,edx,EM_REPLACESEL,TRUE,addr buffer
			.endif
			xor		eax,eax
			jmp		Ex
		.else
			.if eax==VK_ESCAPE && fLB
				;Hide listbox
				invoke ShowWindow,hLB,SW_HIDE
				xor		eax,eax
				jmp		Ex
			.endif
			invoke CallWindowProc,OldEditProc1,hWin,uMsg,wParam,lParam
			push	eax
			.if fLB
				;Show listbox
				invoke ShowWindow,hLB,SW_SHOWNA
			.endif
			pop		eax
			jmp		Ex
		.endif
	.endif
	invoke CallWindowProc,OldEditProc1,hWin,uMsg,wParam,lParam
  Ex:
	ret

EditProc endp

; Export this proc (it is autoexported if MakeDef is enabled with option 2)
DllProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	; This proc handles messages sent from RadASM to our dll
	; Return TRUE to prevent RadASM and other DLL's from

	mov		eax,uMsg
	.if eax==AIM_MDIACTIVATE
		;A new edit window is selected, reset flags and hide listbox
		xor		eax,eax
		dec		eax
		mov		nLine,eax
		mov		nPos,eax
		.if fLB
			invoke ShowWindow,hLB,SW_HIDE
			mov		fLB,FALSE
		.endif
		.if hWin
			invoke GetWindowLong,hWin,0                           ;Get editor type
			.if eax==ID_EDIT
				mov		eax,wParam
				.if eax==hWin
					.if OldMdiChildProc
						;Unsubclass the MdiChild window
						invoke SetWindowLong,hWin,GWL_WNDPROC,OldMdiChildProc
						invoke GetWindowLong,hWin,GWL_USERDATA          ;Get hEdit
						invoke SendMessage,eax,REM_SUBCLASS,0,OldEditProc1
						xor eax, eax
						mov OldMdiChildProc,eax				;Set as unhooked
						mov OldEditProc1,eax				;Set as unhooked
						mov OldEditProc2,eax				;Set as unhooked
					.endif
				.else
					;Subclass the Mdi Child window
					invoke SetWindowLong,hWin,GWL_WNDPROC,offset MdiChildProc
					mov OldMdiChildProc,eax
					mov		eax,hWin
					mov		hMdi,eax
					;Subclass the RAEdit child windows
					invoke GetWindowLong,hWin,GWL_USERDATA
					invoke GetWindowLong,eax,0
					mov		edx,[eax].EDIT.edta.hwnd
					mov		hEdt1,edx
					mov		edx,[eax].EDIT.edtb.hwnd
					mov		hEdt2,edx
					invoke SetWindowLong,hEdt1,GWL_WNDPROC,offset EditProc
					mov OldEditProc1,eax
					invoke SetWindowLong,hEdt2,GWL_WNDPROC,offset EditProc
					mov OldEditProc2,eax
				.endif
			.endif
		.endif

	.elseif eax==AIM_CLOSE
		;Undo all subclassing
		.if OldMdiChildProc
			invoke UnHook,hMdi,offset MdiChildProc,OldMdiChildProc
			mov		OldMdiChildProc,0
		.endif
		.if OldEditProc1
			invoke UnHook,hEdt1,offset EditProc,OldEditProc1
			mov		OldEditProc1,0
		.endif
		.if OldEditProc2
			invoke UnHook,hEdt2,offset EditProc,OldEditProc2
			mov		OldEditProc2,0
		.endif
	.elseif eax==AIM_UNHOOK
		mov		eax,hWin
		mov		ecx,wParam
		mov		edx,lParam
		.if eax==hMdi && ecx==OldMdiChildProc
			;Remove the hook from the chain
			mov		OldMdiChildProc,edx
			mov		eax,TRUE
			jmp		Ex
		.elseif eax==hEdt1 && ecx==OldEditProc1
			;Remove the hook from the chain
			mov		OldEditProc1,edx
			mov		eax,TRUE
			jmp		Ex
		.elseif eax==hEdt2 && ecx==OldEditProc2
			;Remove the hook from the chain
			mov		OldEditProc2,edx
			mov		eax,TRUE
			jmp		Ex
		.endif
	.endif
	xor eax,eax
  Ex:
	ret

DllProc Endp

;#########################################################################

End DllEntry

